//
// This is a part of e-sushi module sourcecode
// for Litestep, a replacement shell.
// Copyright (C) 2002 Mike Edward Moras / e-sushi
//
// This program is free software;
// you can redistribute it and/or modify it under
// the terms of the GNU General Public License
// as published by the Free Software Foundation;
// either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it
// will be useful, but WITHOUT ANY WARRANTY; without
// even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the
// GNU General Public License along with this program;
// if not, write to: Free Software Foundation, Inc.
//                   59 Temple Place - Suite 330
//                   Boston
//                   MA  02111-1307, USA.
//

/*
  27jun02 / e-sushi / M.E.Moras
----------------------------------------------------------
  Implemented sort of a help screen if setup commands
  are missing or incomplete...

  reshaped the 'flow' of the module  and thanks to rabidcow
  and maduin I was able to kill a setting... so there's
  less stuff to setup now: only a loadmodule, an image path
  and a tile/center/stretch command...

  
  miniwallimgpath  ;the path to the BMP you want to use.
                    "$themesdir$sample.bmp" works too ;)
  
  miniwallc        ;this is a bool, if it's there,
                    the wallpaper is centered
  miniwalls        ;this is a bool, if it's there,
                    the wallpaper is streched
  miniwallt        ;this is a bool, if it's there,
                    the wallpaper is tiled
  miniwallstop     ;this is a bool, if it's there,
                    no wallpaper is loaded ;)

  This module auto-unloads. Since it's the first one of
  it's kind to do this, be so kind to remember who did
  it first, ok?
*/

#define WIN32_LEAN_AND_MEAN
#include "../lsapi/lsapi.h"



extern "C" {
    __declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
    __declspec( dllexport ) void quitModule(HINSTANCE dllInst);
}

int initModuleEx(HWND parentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
    int code = 0;
	
	char mybitmap[MAX_PATH];
	char mytmppath[MAX_PATH];
	char mydllpath[MAX_PATH];
	char szValue1[2], szValue2[2];
	HKEY hKey;


if(GetRCBool("miniwallstop", TRUE)==FALSE) //check for module override
{
	if(GetRCBool("miniwallc", TRUE)==TRUE) //center wall
{
	if(RegOpenKeyEx(HKEY_CURRENT_USER, "Control Panel\\Desktop", 0, KEY_WRITE, &hKey) == ERROR_SUCCESS)
{
	strcpy(szValue1, "0");
    strcpy(szValue2, "0");
	RegSetValueEx(hKey, "WallpaperStyle", 0, REG_SZ, (unsigned char *)szValue1, strlen(szValue1) + 1);
    RegSetValueEx(hKey, "TileWallpaper", 0, REG_SZ, (unsigned char *)szValue2, strlen(szValue2) + 1);
    RegCloseKey(hKey);
}
}

	else if(GetRCBool("miniwallt", TRUE)==TRUE) //tile wall
{
	if(RegOpenKeyEx(HKEY_CURRENT_USER, "Control Panel\\Desktop", 0, KEY_WRITE, &hKey) == ERROR_SUCCESS)
{
	strcpy(szValue1, "1");
    strcpy(szValue2, "1");
	RegSetValueEx(hKey, "WallpaperStyle", 0, REG_SZ, (unsigned char *)szValue1, strlen(szValue1) + 1);
    RegSetValueEx(hKey, "TileWallpaper", 0, REG_SZ, (unsigned char *)szValue2, strlen(szValue2) + 1);
    RegCloseKey(hKey);
}
}

	else if(GetRCBool("miniwalls", TRUE)==TRUE) //stretch
{
	if(RegOpenKeyEx(HKEY_CURRENT_USER, "Control Panel\\Desktop", 0, KEY_WRITE, &hKey) == ERROR_SUCCESS)
{
	strcpy(szValue1, "2");
    strcpy(szValue2, "0");
	RegSetValueEx(hKey, "WallpaperStyle", 0, REG_SZ, (unsigned char *)szValue1, strlen(szValue1) + 1);
    RegSetValueEx(hKey, "TileWallpaper", 0, REG_SZ, (unsigned char *)szValue2, strlen(szValue2) + 1);
    RegCloseKey(hKey);
}
}
	else
	{
//Since I'm one of the users always losing readme.txt files,
//here's a help screen if the setup fails somewhere...
MessageBox (NULL,"Ok, getting this box means you loaded miniwall.dll\nbut forgot to set it up right.\n\nPlease use:\n  miniwallimgpath  ;the path to the BMP you want to use.\n\nand one of these:\n  miniwallc  ;center image\n  miniwallt  ;tile image\n  miniwallc  ;stretch image\n\nThat's all... now go have fun!\n\nMike\nhttp://e-sushi.cjb.net","Oops, setup error detected!",MB_OK);
	}
	GetRCLine("miniwallimgpath", mybitmap, MAX_LINE_LENGTH, NULL); //get bmp path
	SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, mybitmap, SPIF_UPDATEINIFILE | SPIF_SENDCHANGE); //put bmp path
}


//thanks to rabidcow for telling me how to get the modulehandle
//and thanks to maduin for setting my brain straight on the dll fetching!
GetModuleFileName(dllInst,mytmppath,MAX_LINE_LENGTH);
//ready
strcpy(mydllpath,"!unloadmodule ");
//set
strcat(mydllpath,mytmppath);
//Go... kick it!
LSExecute(NULL, mydllpath, NULL);
return code;
}

void quitModule(HINSTANCE dllInst)
{
}